;;; ccl-dispatch.el --- dispatcher for CCL compiler programs

;;; Code:

(if (boundp 'MULE)
    ;; Mule 2.x (0 <= x <= 3)
    (load-file "../aux/cclc-mule2.elc")
  ;; Mule 2.4 or newer
  (require 'ccl)
  (cond ((and (= emacs-major-version 20)
	      (or (= emacs-minor-version 3) (= emacs-minor-version 4)))
  ;; Emacs 20.[34] workaround
(defun ccl-compile-write-string (str)
  (setq str (string-as-unibyte str))
  (let ((len (length str)))
    (ccl-embed-code 'write-const-string 1 len)
    (ccl-embed-string len str))
  nil)

(defun ccl-compile-write-repeat (cmd)
  (if (/= (length cmd) 2)
      (error "CCL: Invalid number of arguments: %s" cmd))
  (if (null ccl-loop-head)
      (error "CCL: No outer loop: %s" cmd))
  (let ((arg (nth 1 cmd)))
    (cond ((integerp arg)
	   (ccl-embed-code 'write-const-jump 0 ccl-loop-head)
	   (ccl-embed-data arg))
	  ((stringp arg)
	   (setq arg (string-as-unibyte arg))
	   (let ((len (length arg))
		 (i 0))
	     (ccl-embed-code 'write-string-jump 0 ccl-loop-head)
	     (ccl-embed-data len)
	     (ccl-embed-string len arg)))
	  (t
	   (ccl-check-register arg cmd)
	   (ccl-embed-code 'write-register-jump arg ccl-loop-head))))
  t)
	 )))

(if (fboundp 'set-language-environment)
    (set-language-environment 'Japanese))

;;; ccl-dispatch.el ends here
